/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */

/**
*	This generated bean class MapElement matches the DTD element map-element
*
*	Generated on Mon May 13 13:36:49 PDT 2002
*/

package com.sun.enterprise.deployment.runtime.connector;

import com.sun.enterprise.deployment.runtime.RuntimeDescriptor;

/**
* This class was based on the schema2beans generated one modified
* to remove its dependencies on schema2beans libraries.

* @author  Jerome Dochez
* @version 
*/

public class MapElement extends RuntimeDescriptor
{
    
    static public final String PRINCIPAL = "Principal";	// NOI18N
    static public final String BACKEND_PRINCIPAL = "BackendPrincipal";	// NOI18N
    
    Principal backendPrincipal = null;
    
    // copy constructor
    public MapElement(MapElement other)
    {
	super(other);
    }

    // constructor
    public MapElement()
    {
	super();
    }

    // This attribute is an array containing at least one element
    public void setPrincipal(int index, Principal value)
    {
	this.setValue(PRINCIPAL, index, value);
    }
    
    //
    public Principal getPrincipal(int index)
    {
	return (Principal)this.getValue(PRINCIPAL, index);
    }
    
    // This attribute is an array containing at least one element
    public void setPrincipal(Principal[] value)
    {
	this.setValue(PRINCIPAL, value);
    }
    
    //
    public Principal[] getPrincipal()
    {
	return (Principal[])this.getValues(PRINCIPAL);
    }
    
    // Return the number of properties
    public int sizePrincipal()
    {
	return this.size(PRINCIPAL);
    }
    
    // Add a new element returning its index in the list
    public int addPrincipal(Principal value)
    {
	return this.addValue(PRINCIPAL, value);
    }
    
    //
    // Remove an element using its reference
    // Returns the index the element had in the list
    //
    public int removePrincipal(Principal value)
    {
	return this.removeValue(PRINCIPAL, value);
    }
    
    // This attribute is mandatory
    public void setBackendPrincipal(boolean value)
    {
	this.setValue(BACKEND_PRINCIPAL, new Boolean(value));
    }
    
    //
    public boolean isBackendPrincipal()
    {
	Boolean ret = (Boolean)this.getValue(BACKEND_PRINCIPAL);
	if (ret == null)
	    return false;
	return ret.booleanValue();
    }
    
    // This method verifies that the mandatory properties are set
    public boolean verify()
    {
	return true;
    }
}
